<ion-content class="ion-padding">
    <form on:submit|preventDefault={reportScore} on:change={validate} on:ionChange={validate}>
        <ion-item>
            <ion-label position="floating">Course Name{#if invalidFields.courseName}<span class="failedValidationText">&nbsp;- {invalidFields.courseName}</span>{/if}</ion-label>
            <ion-input on:keyup={(e) => score.courseName = e.currentTarget.value }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Par{#if invalidFields.par}<span class="failedValidationText">&nbsp;- {invalidFields.par}</span>{/if}</ion-label>
            <ion-input type="number" on:keyup={(e) => score.par = Number(e.currentTarget.value) }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Rating{#if invalidFields.courseRating}<span class="failedValidationText">&nbsp;- {invalidFields.courseRating}</span>{/if}</ion-label>
            <ion-input type="number" on:keyup={(e) => score.courseRating = Number(e.currentTarget.value) }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Slope{#if invalidFields.courseSlope}<span class="failedValidationText">&nbsp;- {invalidFields.courseSlope}</span>{/if}</ion-label>
            <ion-input type="number" on:keyup={(e) => score.courseSlope = Number(e.currentTarget.value) }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Score{#if invalidFields.score}<span class="failedValidationText">&nbsp;- {invalidFields.score}</span>{/if}</ion-label>
            <ion-input  type="number" on:keyup={(e) => score.score = Number(e.currentTarget.value) }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Handicap{#if invalidFields.handicap}<span class="failedValidationText">&nbsp;- {invalidFields.handicap}</span>{/if}</ion-label>
            <ion-input  type="number" on:keyup={(e) => score.handicap = Number(e.currentTarget.value) }></ion-input>
        </ion-item>
        <ion-button type="submit" expand="block">Report Score</ion-button>
    </form>
</ion-content>

<script>
import {navigateTo, currentRoute} from 'svelte-grouter'
import * as scoresService from '/lib/ScoresService'
import {outingsByUserStore} from '/client/OutingsStore'
import {currentUserStore} from '/client/UsersStore'
import {layoutStore} from '/client/LayoutStore'

$layoutStore.title = 'Report Score'
$layoutStore.showBack = true

let invalidFields = {}, submitted = false
$: console.log(invalidFields) // logging invalid fields until we figure out ionic form validation
$: console.log(score)
let score
$: user = $currentUserStore

$: if (user) {
    score = {
        courseName: '',
        playerName: `${user.firstName} ${user.lastName}`,
        score: '',
        par: '',
        rating: '',
        slope: '',
        outingId: $currentRoute.params.id
    }
}
function reportScore() {
    submitted = true
    if (!validate()) return false
    scoresService.reportScore(score)
    .then(scoreId => {
        console.log('Created a new score with id ', scoreId)
        navigateTo('leaderboard', $currentRoute.params)
    })
}

function validate() {
    if (submitted) {
        invalidFields = scoresService.validate(score)
        if (Object.keys(invalidFields).length > 0 ) {
            return false
        }
    }
    return true
}


</script>

<style>
ion-button {
    margin-top: 50px;
}
</style>